from flask import render_template, send_file, redirect, url_for, request, url_for, Blueprint
from flask import *
import MySQLdb
from flask_login import login_required, current_user
from PIL import Image, ImageOps, ImageFilter, ImageEnhance, UnidentifiedImageError
import cv2
from io import BytesIO
import io
import numpy as np
import cred

edit_routes = Blueprint('edit_routes',__name__, static_folder="static", template_folder="templates")
edit_routes.port = 63007
port = edit_routes.port

# Got a little help for this one from here, had to guess what to change,
# took me 6 tries, got it on the last combination
# https://www.analyticsvidhya.com/blog/2021/07/an-interesting-opencv-application-creating-filters-like-instagram-and-picsart/

@edit_routes.route('/edit/<int:id>')
@login_required
def singleImage(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )

    uploadedBy = current_user.id
    mycursor = mydb.cursor()
    mycursor.execute("SELECT image_id from images where image_id =%s and user_id = %s",(id,uploadedBy));
    check = mycursor.rowcount
    mydb.commit()
    print(check)
    print(uploadedBy)
    
    if check == 1:
        return render_template('singleimage.html',imageID=id)
    else:
        return '<h1>Image Not Yours To Edit! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

# Adds a sepia (old timey) look to an image
@edit_routes.route('/sepia/<int:id>') 
@login_required
def sepia(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )

    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'
    
    sepia = np.array(img, dtype = np.float64)
    sepia = cv2.transform(sepia, np.matrix([[0.393, 0.769, 0.189],
                                    [0.349, 0.686, 0.168],
                                    [0.272, 0.534, 0.131]]))
    sepia[np.where(sepia > 255)] = 255
    sepia = np.array(sepia, dtype=np.uint8)
    
    sendFile = Image.fromarray(sepia)

    imgBytes = io.BytesIO()
    sendFile.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='sepia-'+str(id)+'.JPEG')

# adds an HDR affect to an image
@edit_routes.route('/HDR/<int:id>') 
@login_required
def HDR(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )

    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'
    
    hdr = np.array(img)
    hdr = cv2.detailEnhance(hdr, sigma_s=12, sigma_r=0.15)
    sendFile = Image.fromarray(hdr)

    imgBytes = io.BytesIO()
    sendFile.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='HDR-'+str(id)+'.JPEG')

# adds a greyscle affect to an image
@edit_routes.route('/greyscale/<int:id>') 
@login_required
def greyScale(id):
    mydb = MySQLdb.connect(host=cred.host,user=cred.user,password=cred.password, database=cred.database)
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = ImageOps.grayscale(img)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='greyscale-'+str(id)+'.JPEG')

# increase contrast of an image
@edit_routes.route('/contrast/<int:id>',methods=['POST']) 
@login_required
def contrast(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    contrastValue = request.form['contrast']
    img = ImageOps.autocontrast(img,cutoff=int(contrastValue), ignore=None, mask=None, preserve_tone=False)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='contrast-'+str(id)+'.JPEG') 

# increase/decreases brightness of an image
@edit_routes.route('/brighten/<int:id>',methods=['POST']) 
@login_required
def brighten(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    brightenValue = request.form['brighten']
    img = ImageEnhance.Brightness(img)
    img = img.enhance(float(brightenValue))
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='brighten-'+str(id)+'.JPEG')    

# adds a "solarize" affect to an image
@edit_routes.route('/solarize/<int:id>') 
@login_required
def solarize(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = ImageOps.solarize(img)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='solarized-'+str(id)+'.JPEG')

# adds an "inverted" affect to an image
@edit_routes.route('/invert/<int:id>') 
@login_required
def invert(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'
        
    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = ImageOps.invert(img)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='inverted-'+str(id)+'.JPEG')

# mirrors an image
@edit_routes.route('/mirror/<int:id>') 
@login_required
def mirror(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = ImageOps.mirror(img)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='mirror-'+str(id)+'.JPEG')

# flips an image
@edit_routes.route('/flip/<int:id>') 
@login_required
def flip(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = ImageOps.flip(img)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='flip-'+str(id)+'.JPEG')

# adds a "blur" affect to an image
@edit_routes.route('/blur/<int:id>') 
@login_required
def blur(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = img.filter(ImageFilter.BLUR)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='BLUR-'+str(id)+'.JPEG')

# adds a contour affect to an image
@edit_routes.route('/contour/<int:id>') 
@login_required
def contour(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = img.filter(ImageFilter.CONTOUR)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='CONTOUR-'+str(id)+'.JPEG')

# adds an emboos affect to an image
@edit_routes.route('/emboss/<int:id>') 
@login_required
def emboss(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = img.filter(ImageFilter.EMBOSS)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='EMBOSS-'+str(id)+'.JPEG')

# adds an edges affect to an image
@edit_routes.route('/edges/<int:id>') 
@login_required
def edges(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database )
    mycursor = mydb.cursor()
    mycursor.execute("select image_file from images where image_id = %s",(id,));
    img= mycursor.fetchall()
    mycursor.close()
    mydb.close()

    try:
        img = img[0][0]
        img=Image.open(BytesIO(img))
    except IndexError:
        return render_template("no-file.html",port = port)
    except UnidentifiedImageError:
        delete(id)
        return '<h1>Currupted Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(current_user.username)+'/gallary"/> </h1>'

    if img.mode in ("RGBA", "P"):
        img = img.convert("RGB")
    imgBytes = io.BytesIO()
    img = img.filter(ImageFilter.FIND_EDGES)
    img.save(imgBytes, format='JPEG')
    imgBytes.seek(0)
    return send_file(imgBytes,attachment_filename='edges-'+str(id)+'.JPEG')

# given an image id, deletes an image if the user deleting the image owns the image
@edit_routes.route('/delete/<int:id>')
@login_required
def delete(id):
    mydb = MySQLdb.connect(
    host = cred.host,
    user = cred.user,
    password = cred.password,
    database = cred.database
)
    user = current_user.username
    mycursor = mydb.cursor()
    mycursor.execute("SELECT image_id FROM images WHERE image_id = %s",(id,));
    checkExists = mycursor.rowcount
    mycursor.execute("DELETE from images where image_id = %s and user_id = %s",(id,current_user.id));
    check = mycursor.rowcount
    mycursor.execute("DELETE from likesDislikes where image = %s and user_id =%s",(id,current_user.id));
  
    mydb.commit()
    mydb.close

    if not checkExists: 
        return '<h1>No Such Image! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(user)+'/gallary"/> </h1>'
    elif check:
        return redirect(url_for('gallary', userName = user))
    else:
        return '<h1>Not Your File to Delete! <meta http-equiv="refresh" content="3;url=http://euclid.nmu.edu:'+str(port)+'/'+str(user)+'/gallary"/> </h1>'